[划分树] POJ 2104 K-th Number

K-th Number

Time Limit: 20000MS   Memory Limit: 65536K
Total Submissions: 51732   Accepted: 17722
Case Time Limit: 2000MS

Description

You are working for Macrohard company in data structures department. After failing your previous task about key insertion you were asked to write a new data structure that would be able to return quickly k-th order statistics in the array segment. 
That is, given an array a[1...n] of different integer numbers, your program must answer a series of questions Q(i, j, k) in the form: "What would be the k-th number in a[i...j] segment, if this segment was sorted?" 
For example, consider the array a = (1, 5, 2, 6, 3, 7, 4). Let the question be Q(2, 5, 3). The segment a[2...5] is (5, 2, 6, 3). If we sort this segment, we get (2, 3, 5, 6), the third number is 5, and therefore the answer to the question is 5.

Input

The first line of the input file contains n --- the size of the array, and m --- the number of questions to answer (1 <= n <= 100 000, 1 <= m <= 5 000). 
The second line contains n different integer numbers not exceeding 109 by their absolute values --- the array for which the answers should be given. 
The following m lines contain question descriptions, each description consists of three numbers: i, j, and k (1 <= i <= j <= n, 1 <= k <= j - i + 1) and represents the question Q(i, j, k).

Output

For each question output the answer to it --- the k-th number in sorted a[i...j] segment.

Sample Input

7 3
1 5 2 6 3 7 4
2 5 3
4 4 1
1 7 3

Sample Output

5
6
3

Hint

This problem has huge input,so please use c-style input(scanf,printf),or you may got time limit exceed.

Source

Northeastern Europe 2004, Northern Subregion

原题大意:给一组数。对于每个查询区间,找出第k小的数。

解题思路:划分树或主席树的裸题,POJ还有一个类似的题目 POJ 2761.

这两道题的代码一样都可以过。

所谓划分树,类似于在已经知道区间中位数的情况下的快排,比中位数小的都放左边,大的分右边,相等的看看左边有没有空,有空放左边,没空放右边,相对位置不变,并记录每次的左右子树划分情况。

如果所求第k小的树,每次我们看看有多少数在左边,就可以知道该查左区间还是右区间。对查询区间做了处理后递归下去即可得出唯一的数值。

#include<stdio.h>
#include<algorithm>
using namespace std;
int tree[20][110001],sorted[110001],left[20][110001];
void build(int dep,int l,int r)
  {
  	 int mid=(l+r)>>1,i,midnum=mid-l+1,sonl=l,sonr=mid+1;
  	 for(i=l;i<=r;++i) if(sorted[i]<sorted[mid]) --midnum;  //寻找能放入左子树中值的个数
  	 for(i=l;i<=r;++i)
  	   {
 if(i==l) left[dep][i]=0; else left[dep][i]=left[dep][i-1]; //对不同的区间,进行左
//树个数初始化
  	   	  if(tree[dep][i]==sorted[mid])
  	   	    {
  	   	       if(midnum)
  	   	         {
  	   	         	--midnum;
  	   	         	++left[dep][i];
                    tree[dep+1][sonl++]=tree[dep][i]; //统计进入左子树的个数,并更新//下一层树
				 } else tree[dep+1][sonr++]=tree[dep][i];
		    } else
		  if(tree[dep][i]<sorted[mid])                 //比中间值小,入左子树
		    {
		      ++left[dep][i];
		      tree[dep+1][sonl++]=tree[dep][i];
			} else tree[dep+1][sonr++]=tree[dep][i];   //比中间值小,入右子树
	   }
	 if(l==r) return;                                //如果是叶子结点,返回
	 build(dep+1,l,mid);                            //递归左右子树
	 build(dep+1,mid+1,r);
  }
int query(int dep,int l,int r,int ql,int qr,int k)
  {
  	 int l_ql,ql_qr,mid=(l+r)>>1;
  	 if(l==r) return tree[dep][l];                      //如果找到值,返回
  	 if(l==ql)                                     //恰好是所求左区间为递归左区间
  	   {                                         //
  	   	  l_ql=0;
  	   	  ql_qr=left[dep][qr];
	   } else
	   {
	   	  l_ql=left[dep][ql-1];                     //l到ql-1的入左区间数
	   	  ql_qr=left[dep][qr]-l_ql;                  //ql到qr的左区间数
	   }
	 if(k<=ql_qr) return query(dep+1,l,mid,l+l_ql,l+l_ql+ql_qr-1,k); else   //递归下一区间
	 return query(dep+1,mid+1,r,mid+1+ql-l_ql-l,mid+1+qr-ql_qr-l_ql-l,k-ql_qr);
    //右区间有点乱,ql-l-l_ql即l到ql-1中入右区间的个数依次类推
  }
int main()
  {
  	int n,m,i,ql,qr,qk;
  	scanf("%d%d",&n,&m);
  	for(i=1;i<=n;++i)
  	  {
  	  	scanf("%d",&tree[0][i]);
  	  	sorted[i]=tree[0][i];
	  }
	sort(sorted+1,sorted+n+1);
	build(0,1,n);
	while(m--)
	  {
	  	 scanf("%d%d%d",&ql,&qr,&qk);
	  	 printf("%d\n",query(0,1,n,ql,qr,qk));
	  }
  	return 0;
  }

  

时间: 2024-10-14 06:37:26

[划分树] POJ 2104 K-th Number的相关文章

HDU 4417 (划分树+区间小于k统计)

题目链接:  http://acm.hdu.edu.cn/showproblem.php?pid=4417 题目大意:给定一个区间,以及一个k值,求该区间内小于等于k值的数的个数.注意区间是从0开始的. 解题思路: 首先这题线段树可以解.方法是维护一个区间最大值max,一个区间点个数s,如果k>max,则ans=s+Q(rson),否则ans=Q(lson). 然后也可以用求区间第K大的划分树来解决,在对原来求第K大的基础上改改就行,方法如下: Build方法同第K大. 对于Query: ①左区

划分树 静态第k大

划分树是保存了快速排序的过程的树,可以用来求静态第k小的数 如果,划分树可以看做是线段树,它的左孩子保存了mid-L+1 个 小于等于 a[mid] 的数字,  右孩子保存了 R-mid个大于等于a[mid]的数字 数组a是排序过后的数组,而划分树保存的是原数组的数据, 划分树的构造就是将上一层[l,r]个数的 mid-l+1个数划分到左子区间,r-(mid-l+1)个数划分到了右子区间 void build(int l, int r, int rt) { if (l == r) return;

POJ 2104:K-th Number(主席树静态区间k大)

题目大意:对于一个序列,每次询问区间[l,r]的第k大树. 分析: 主席树模板题 program kthtree; type point=record l,r,s:longint; end; var t:array[0..100000*50]of point; a,b,id,root:array[0..100000]of longint; n,i,m,x,y,k,v,len:longint; procedure qsort(l,h:longint); var i,j,t,m:longint; b

【POJ 2104】 K-th Number 主席树模板题

达神主席树讲解传送门:http://blog.csdn.net/dad3zz/article/details/50638026 2016-02-23:真的是模板题诶,主席树模板水过.今天新校网不好,没有评测,但我立下flag这个代码一定能A.我的同学在自习课上考语文,然而机房党都跑到机房来避难了\(^o^)/~ #include<cstdio> #include<cstring> #include<algorithm> #define for1(i,a,n) for(i

POJ 2104:K-th Number(整体二分)

http://poj.org/problem?id=2104 题意:给出n个数和m个询问求区间第K小. 思路:以前用主席树做过,这次学整体二分来做.整体二分在yr大佬的指点下,终于大概懂了点了.对于二分能够解决的询问,如果有多个,那么如果支持离线处理的话,那么就可以使用整体二分了. 在这题二分可行的答案,根据这个答案,把询问操作丢在左右两个队列里面分别递归继续按这样处理.注释里写的很详细. 1 #include <iostream> 2 #include <cstdlib> 3 #

【POJ 2104】K-th Number

Description You are working for Macrohard company in data structures department. After failing your previous task about key insertion you were asked to write a new data structure that would be able to return quickly k-th order statistics in the array

POJ 2104 K-th Number(区间第k大数)(平方分割,归并树,划分树)

题目链接: http://poj.org/problem?id=2104 解题思路: 因为查询的个数m很大,朴素的求法无法在规定时间内求解.因此应该选用合理的方式维护数据来做到高效地查询. 如果x是第k个数,那么一定有 (1)在区间中不超过x的数不少于k个 (2)在区间中小于x的数有不到k个 因此,如果可以快速求出区间里不超过x的数的个数,就可以通过对x进行二分搜索来求出第k个数是多少. 接下来,我们来看一下如何计算在某个区间里不超过x个数的个数.如果不进行预处理,那么就只能遍历一遍所有元素.

POJ 2104 K-th Number(区间第k大数)(平方切割,归并树,划分树)

题目链接: http://poj.org/problem? id=2104 解题思路: 由于查询的个数m非常大.朴素的求法无法在规定时间内求解. 因此应该选用合理的方式维护数据来做到高效地查询. 假设x是第k个数,那么一定有 (1)在区间中不超过x的数不少于k个 (2)在区间中小于x的数有不到k个 因此.假设能够高速求出区间里不超过x的数的个数.就能够通过对x进行二分搜索来求出第k个数是多少. 接下来,我们来看一下怎样计算在某个区间里不超过x个数的个数. 假设不进行预处理,那么就仅仅能遍历一遍全

poj 2104 K-th Number(划分树模板)

划分树模板题,敲上模板就ok了. #include<algorithm> #include<iostream> #include<cstring> #include<vector> #include<cstdio> #include<cmath> #include<queue> #include<stack> #include<map> #include<set> #define MP